/**********************************************************
 * @brief Simulation code for Binary Consensus in Anonymous Asynchronous Systems using Coins and Failure Detectors.
 * @date July 2018
 * @author Javier Martín Rueda, javier.martin@upm.es
 * @author José Luis López-Presa, joseluis.llopezp@upm.es
 * @author Ernesto Jiménez, ernes@etsisi.upm.es
 **********************************************************/


#ifndef _CONSENSUS_H_
#define _CONSENSUS_H_

#include "Channel.h"
#include "Coin.h"

class Consensus {
public:
	Consensus(unsigned int numProcesses, int idProcess);
	virtual ~Consensus();
	virtual int propose(int v) = 0;
	void debug(int level);
	int getDebug() const { return _debugLevel; }
	const unsigned int numProcesses;
	const int idProcess;
protected:
	int _debugLevel;
};

#endif
