/**********************************************************
 * @brief Simulation code for Binary Consensus in Anonymous Asynchronous Systems using Coins and Failure Detectors.
 * @date July 2018
 * @author Javier Martín Rueda, javier.martin@upm.es
 * @author José Luis López-Presa, joseluis.llopezp@upm.es
 * @author Ernesto Jiménez, ernes@etsisi.upm.es
 **********************************************************/


#ifndef __EVENTS_H__
#define __EVENTS_H__

#include <vector>
#include <iostream>

class VectorClock
{
public:
    bool operator == (const VectorClock& other) const;
    bool operator <= (const VectorClock& other) const;
    bool operator < (const VectorClock& other) const;
    VectorClock& operator += (const VectorClock& other);
    unsigned int& operator [] (int i);
    friend std::ostream& operator << (std::ostream& out, const VectorClock& r);
    void resize(unsigned int newSize);
private:
    std::vector<unsigned int> _t;
};

class Event {
public:
    Event();
    virtual ~Event();
    void timestamp(const VectorClock& t);
    const VectorClock& t() const { return _t; }
private:
    VectorClock _t;
};

#endif
